﻿/**
あ
*/
module nemuxi.negui.control.label.label;

debug import std.stdio: wl = writefln, pl = printf;
debug(label) void main() {}

import win32.windows;

import nemuxi.negui.system.base;
import nemuxi.negui.draw.draw;
import nemuxi.negui.draw.icon;
import nemuxi.negui.draw.bitmap;
public import nemuxi.negui.negui;
public import nemuxi.negui.control.control;


/**
*/
abstract class Statc: Control, INotify, IOwnerDraw {
	/**
	History:
		1.032:
			[P] 処理内容変更。
	*/
	this(NeGui Owner, ITEM_ID Id) {
		NEGUIINFO NeGuiInfo;
		
		NeGuiInfo.owner     = Owner;
		NeGuiInfo.id        = Id;
		
		this(NeGuiInfo);
	}
	/**
	History:
		1.032:
			新規作成。
	*/
	override this(ref NEGUIINFO NeGuiInfo) {
		NeGuiInfo.className = "STATIC";

		super(NeGuiInfo);
	}
	
	mixin(SMixInItemStyleGetSet("notify",    q{SS_NOTIFY},    false));
	mixin(SMixInItemStyleGetSet("ownerDraw", q{SS_OWNERDRAW}, false));

	static enum EVENT: MESSAGETYPE {
		CLICKED = STN_CLICKED, /// クリックされた
		DBLCLK  = STN_DBLCLK , /// ダブルクリックされた
		ENABLE  = STN_ENABLE , /// 有効になったとき
		DISABLE = STN_DISABLE, /// 無効になったとき
	}
}

/**
History:
	1.00β18:
		[B] horizonAlignにおいてHORIZON_ALIGN.RIGHTとHORIZON_ALIGN.CENTERが逆になっていた。
*/
class TextLabel: Statc, IHorizonAlign {
	mixin ControlClass;

	mixin(SMixInItemStyleGetSetEx!(HORIZON_ALIGN, DWORD)(
		"horizonAlign", true, [
		q{HORIZON_ALIGN.RIGHT}, q{HORIZON_ALIGN.CENTER}, q{HORIZON_ALIGN.LEFT},
		q{SS_RIGHT},            q{SS_CENTER},            q{SS_LEFT}
	]));
	
	mixin(SMixInItemStyleGetSet("verticalCenter", q{SS_CENTERIMAGE}, false));

	
	mixin(SMixInItemStyleGetSet("noPrefix", q{SS_NOPREFIX}, false));
	mixin(SMixInItemStyleGetSet("noWordwrap", q{SS_LEFTNOWORDWRAP}, false));

	static enum ELLIPSIS: DWORD {
		DURING = SS_PATHELLIPSIS,  /// 途中
		END    = SS_ENDELLIPSIS, /// 最後
	} // 一度きりの人生
	mixin(SMixInItemStyleGetSetEx!(ELLIPSIS, DWORD)(
		"ellipsis", false, [
		q{ELLIPSIS.DURING}, q{ELLIPSIS.END},   
		q{SS_PATHELLIPSIS}, q{SS_ENDELLIPSIS}
	]));



}

private enum {
	SS_CENTERIMAGE = 0x00000200,
	SS_RIGHTJUST   = 0x00000400,
}

abstract class PictureLabel: Statc {
	mixin ControlClass;
	
	abstract Draw image();
	abstract Draw image(Draw draw);

	mixin(SMixInItemStyleGetSet("realItemSize", q{SS_REALSIZEIMAGE}, false));
	
	static enum POSITION {
		LEFT_TOP     = 0,
		CENTER       = SS_CENTERIMAGE,
		RIGHT_BOTTOM = SS_RIGHTJUST
	}
	mixin(SMixInItemStyleGetSetEx!(POSITION, DWORD)(
		"position", false, [
		q{POSITION.CENTER}, q{POSITION.RIGHT_BOTTOM}, q{POSITION.LEFT_TOP},
		q{SS_CENTERIMAGE},  q{SS_RIGHTJUST},          q{0}
	]));
	
	static enum IMAGE_TYPE {
		ICON   = SS_ICON,
		BITMAP = SS_BITMAP,
	}
	mixin(SMixInItemStyleGetSetEx!(IMAGE_TYPE, DWORD)(
		"imageType", false, [
		q{IMAGE_TYPE.ICON}, q{IMAGE_TYPE.BITMAP},
		q{SS_ICON},         q{SS_BITMAP}
	]));
}

class BoxLabel: Statc {
	mixin ControlClass;

	static enum BOX {
		BORDER  = SS_BLACKFRAME, /// ウィンドウの枠と同じ色（デフォルトでは黒）の枠を持つボックスを作成します。
		DESKTOP = SS_GRAYFRAME, /// 画面の背景 (デスクトップ) と同じ色（デフォルトでは灰色）の枠を持つボックスを作成します。
		WINDOW  = SS_WHITEFRAME, /// ウィンドウの背景と同じ色（デフォルトでは白）の枠を持つボックスを作成します。
	}

	mixin(SMixInItemStyleGetSetEx!(BOX, DWORD)(
		"box", false, [
		q{BOX.BORDER},    q{BOX.DESKTOP},  q{BOX.WINDOW},
		q{SS_BLACKFRAME}, q{SS_GRAYFRAME}, q{SS_WHITEFRAME}
	]));

	static enum AREA {
		BORDER  = SS_BLACKRECT, /// ウィンドウの枠と同じ色で塗りつぶされた長方形を作成します。Windowsのデフォルトの配色は黒です。
		DESKTOP = SS_GRAYRECT, /// 画面の背景（デスクトップ）と同じ色で塗りつぶされた長方形を作成します。Windowsのデフォルトの配色は灰色です。
		WINDOW  = SS_WHITERECT, /// ウィンドウの背景と同じ色の枠で塗りつぶされた長方形を作成します。Windowsのデフォルトの配色は白です。
	}
	mixin(SMixInItemStyleGetSetEx!(AREA, DWORD)(
		"area", false, [
		q{AREA.BORDER}, q{AREA.DESKTOP}, q{AREA.WINDOW},
		q{SS_BLACKRECT}, q{SS_GRAYRECT}, q{SS_WHITERECT}
	]));
}

class IconLabel: PictureLabel {

	override this(NeGui Owner, ITEM_ID Id) {
		super(Owner, Id);
		imageType = IMAGE_TYPE.ICON;
	}

	override Draw image() {
		auto icon=super.send(STM_GETICON, NONE, NONE);

		return icon
			? new Icon(cast(HICON)icon, false)
			: null
		;
	}
	override Draw image(Draw draw)
	in {
		assert(cast(Icon)draw);
	}
	body {
		auto icon=send(STM_SETICON, cast(WPARAM)draw(), NONE);
		
		return icon
			? new Icon(cast(HICON)icon, false)
			: null
		;
	}
}

